/* nkfu.dll nfkudll.c */
/* URL: http://homepage3.nifty.com/TaN/ */

/*WIN32DLL*/
/* ̃o[WXVĂB */
#define DLL_VERSION   "2.0.9.0"

/* nkf32.dll main */
#include <windows.h>
#include <tchar.h>
#include <stdarg.h>
#include <stdio.h>

int dllprintf(FILE *fp,char *fmt,...){ return 0; }

#include "nkf.c"

#ifndef GUESS
#define GUESS 64
#endif /*GUESS*/

typedef struct {
	LPSTR optStr0;
	char *guessbuffA;
	int userdata;
} NkfObject;

static NkfObject nkfObj;

static const unsigned char *cin = NULL;
static FNNkfConvertStreamCallback cin_callback = NULL;
static int nin = -1;
static int ninmax = -1;
static int std_getc_mode = 1;

int std_getc(FILE *f)
{
	if (nkf_buf_length(nkf_state->std_gc_buf)){
		return nkf_buf_pop(nkf_state->std_gc_buf);
	} else {
		if (cin_callback){
			return cin_callback(0, nkfObj.userdata);
		}
		if ( std_getc_mode == 1 ) {
			return getc(f);
        }
        if ( std_getc_mode == 2 && cin != NULL ) {
            if ( ninmax >= 0 ) {
                if ( nin >= ninmax ) {
                    return EOF;
                } else {
					nin++;
                    return *cin++;
                }
            } else {
                if ( *cin ) {
                    return *cin++;
                } else {
                    return EOF;
                }
            }
        }
    }
    return EOF;
}

static FILE *fout = NULL;
static FNNkfConvertStreamCallback cout_callback = NULL;
static unsigned char *cout = NULL;
static int nout = -1;
static int noutmax = -1;
static int std_putc_mode = 1;

void std_putc(int c)
{
	if(c!=EOF)
	{
		if (cout_callback){
			cout_callback(c, nkfObj.userdata);
		}
		if ( (std_putc_mode & 1) && fout != NULL ) {
			putc(c,fout);
		}
        if ( (std_putc_mode & 4) && nout != -1 ) {
            if ( noutmax >= 0 && nout >= noutmax ) std_putc_mode &= ~2;
            nout++;
        }
        if ( (std_putc_mode & 2) && cout != NULL ) {
            *cout++ = c;
        }
    }
}

char *print_guessed_code(char *guessbuffA, char *filename)
{
	const char *codename = get_guessed_code();
	if (filename != NULL) {
		guessbuffA = realloc(guessbuffA,(strlen(filename) + GUESS + 1) * sizeof (char) );
		sprintf(guessbuffA,"%s:%s", filename,codename);
	} else {
		guessbuffA = realloc(guessbuffA,(GUESS + 1) * sizeof (char) );
		sprintf(guessbuffA,"%s", codename);
	}
	return guessbuffA;
}

void reinitdll(void)
{
	cin = NULL;
	cin_callback = NULL;
	nin = -1;
    ninmax = -1;
    std_getc_mode = 1;
    fout = stdout;
    cout = NULL;
	cout_callback = NULL;
	nout = -1;
    noutmax = -1;
    std_putc_mode = 1;
}

BOOL scp(LPSTR s,LPSTR t,DWORD n)
{
    while ( n ) {
        if ( (*s = *t) == 0 ) return TRUE;
        if ( --n == 0 ) {
            *s = 0;
            break;
        }
        s++;
        t++;
    }
    return FALSE;
}

#ifdef UNICODESUPPORT
BOOL wscp(LPWSTR s,LPWSTR t,DWORD n)
{
    while ( n ) {
        if ( (*s = *t) == 0 ) return TRUE;
        if ( --n == 0 ) {
            *s = 0;
            break;
        }
        s++;
        t++;
	}
	return FALSE;
}
#endif /*UNICODESUPPORT*/

LPCSTR WINAPI __export GetNkfVersion()
{
	return DLL_VERSION;
}

int WINAPI __export SetNkfOption(LPCSTR optStr)
{
	LPSTR p;
	int len;
	LPSTR optStr0;

	optStr0 = nkfObj.optStr0;

	if ( *optStr == '-' ) {
		len = strlen(optStr) + 1;
		p = realloc(optStr0,len);
		strcpy(p,optStr);
	} else {
		len = strlen(optStr) + 2;
		p = realloc(optStr0,len);
		*p = '-';
		strcpy(p + 1,optStr);
	}
	nkfObj.optStr0 = p;
    return 0;
}

void options0(NkfObject *obj)
{
	reinit();
	if ( obj->optStr0 != NULL ) {
		options(obj->optStr0);
	}
}

void NkfConvert(LPSTR outStr, LPCSTR inStr)
{
	options0(&nkfObj);
	std_putc_mode = 2;
	cout = outStr;
	cout_callback = NULL;
	noutmax = -1;
	nout = -1;
	std_getc_mode = 2;
	cin = inStr;
	cin_callback = NULL;
	ninmax = -1;
	nin = -1;
	kanji_convert(NULL);
	*cout = 0;
}

BOOL WINAPI __export NkfConvertString(LPSTR outStr,DWORD nOutBufferLength /*in Bytes*/,LPDWORD lpBytesReturned /*in Bytes*/, LPCSTR inStr,DWORD nInBufferLength /*in Bytes*/)
{
    if ( inStr == NULL ) return FALSE;
    options0(&nkfObj);
    std_putc_mode = 6;
    cout = outStr;
	cout_callback = NULL;
	noutmax = nOutBufferLength;
	nout = 0;
	std_getc_mode = 2;
	cin = inStr;
	cin_callback = NULL;
	ninmax = nInBufferLength;
	nin = 0;
	kanji_convert(NULL);
	*lpBytesReturned = nout;
	if ( nout < noutmax ) *cout = 0;
	return TRUE;
}

BOOL WINAPI __export NkfConvertStream(FNNkfConvertStreamCallback inStrm, FNNkfConvertStreamCallback outStrm, int userdata)
{
	nkfObj.userdata = userdata;
	options0(&nkfObj);
	std_putc_mode = 0;
	cout = NULL;
	cout_callback = outStrm;
	noutmax = 0;
	nout = 0;
	std_getc_mode = 0;
	cin = NULL;
	cin_callback = inStrm;
	ninmax = 0;
	nin = 0;
	kanji_convert(NULL);
	return TRUE;
}

void WINAPI __export ToHankaku(LPSTR inStr)
{
	unsigned char *p;
	int len;

	len = strlen(inStr) + 1;
	p = malloc(len);
	if ( p == NULL ) return;
	memcpy(p,inStr,len);
	options("-ZSs");
	NkfConvert(inStr,p);
	free(p);
}

BOOL WINAPI __export ToHankakuSafe(LPSTR outStr,DWORD nOutBufferLength /*in Bytes*/,LPDWORD lpBytesReturned /*in Bytes*/,LPCSTR inStr,DWORD nInBufferLength /*in Bytes*/)
{
	options("-ZSs");
	return NkfConvertString(outStr,nOutBufferLength,lpBytesReturned,inStr,nInBufferLength);
}

void WINAPI __export ToZenkakuKana(LPSTR outStr, LPCSTR inStr)
{
	options("-Ss");
	NkfConvert(outStr, inStr);
}

BOOL WINAPI __export ToZenkakuKanaSafe(LPSTR outStr,DWORD nOutBufferLength /*in Bytes*/,LPDWORD lpBytesReturned /*in Bytes*/,LPCSTR inStr,DWORD nInBufferLength /*in Bytes*/)
{
	options("-Ss");
	return NkfConvertString(outStr,nOutBufferLength,lpBytesReturned,inStr,nInBufferLength);
}

void WINAPI __export EncodeSubject(LPSTR outStr ,LPCSTR inStr)
{
	options("-jM");
	NkfConvert(outStr, inStr);
}

BOOL WINAPI __export EncodeSubjectSafe(LPSTR outStr,DWORD nOutBufferLength /*in Bytes*/,LPDWORD lpBytesReturned /*in Bytes*/,LPCSTR inStr,DWORD nInBufferLength /*in Bytes*/)
{
	options("-jM");
	return NkfConvertString(outStr,nOutBufferLength,lpBytesReturned,inStr,nInBufferLength);
}

void WINAPI __export ToMime(LPSTR outStr ,LPCSTR inStr)
{
	EncodeSubject(outStr,inStr);
}

int WINAPI __export NkfGetKanjiCode(VOID)
{
	int iCode=0;
	/* if(iconv == s_iconv)iCode=0; */ /* 0:VtgJIS */
	if(iconv == w_iconv)iCode=3; /* UTF-8 */
	else if(iconv == w_iconv16){
		if(input_endian == ENDIAN_BIG)iCode=5; /* 5:UTF-16BE */
		else iCode=4; /* 4:UTF-16LE */
	}else if(iconv == e_iconv){
		if(estab_f == FALSE)iCode=2; /* 2:ISO-2022-JP */
		else iCode=1; /* 1:EUC */
	}
	return iCode;
}

BOOL WINAPI __export NkfConvertFileW(LPCWSTR fInName, LPCWSTR fOutName)
{
	FILE *fin;

	options0(&nkfObj);

	if ((fin = _wfopen(fInName, L"rb")) == NULL) return FALSE;
	if((fout=_wfopen(fOutName, L"wb")) == NULL) {
		fclose(fin);
		return FALSE;
	}
	cin = NULL;
	cin_callback = NULL;
	nin = -1;
	ninmax = -1;
	std_getc_mode = 1;
	cout = NULL;
	cout_callback = NULL;
	nout = -1;
	noutmax = -1;
	std_putc_mode = 1;
	kanji_convert(fin);
	fclose(fin);
	fclose(fout);
	return TRUE;
}

LPCSTR WINAPI __export GetNkfGuess()
{
	return nkfObj.guessbuffA = print_guessed_code(nkfObj.guessbuffA, NULL);
}

#pragma argsused
int WINAPI DllEntryPoint(HINSTANCE hinst, unsigned long reason, void* lpReserved)
{
	return 1;
}
//---------------------------------------------------------------------------

